%def_disable werror
%def_enable sdl
%def_enable curses
%def_enable vnc_tls
# Sound adapter emulation
%def_enable adlib
%def_enable ac97
%def_enable gus
# Audio drivers
%def_enable alsa
%def_enable esd

%define _group _%name
%define rulenum 90

Name: kvm
Version: 66
Release: alt1
Summary: Kernel Virtual Machine virtualization environment
Group: Emulators
License: %gpl2plus
URL: http://%name.qumranet.com/%{name}wiki
Source: %name-%version.tar.bz2
Patch: qemu-flags.patch
ExclusiveArch: %ix86 x86_64
Requires: qemu-system
Provides: qemu-%name = %version-%release

# Automatically added by buildreq on Thu Mar 20 2008 (-bi)
#BuildRequires: esound-devel libSDL-devel libalsa-devel libgnutls-devel libncurses-devel tetex-core zlib-devel

BuildRequires: zlib-devel rpm-build-licenses kernel-build-tools
%{?_enable_sdl:BuildRequires: libSDL-devel}
%{?_enable_curses:BuildRequires: libncurses-devel}
%{?_enable_alsa:BuildRequires: libalsa-devel}
%{?_enable_esd:BuildRequires: esound-devel}
%{?_enable_vnc_tls:BuildRequires: libgnutls-devel}

%description
The Kernel Virtual Machine provides a virtualization enviroment for
processors with hardware support for virtualization: Intel's VT and
AMD's AMD-V.


%package -n kernel-source-%name
Summary: %name Linux kernel module sources
Group: Development/Kernel

%description -n kernel-source-%name
This is %name sources, a Linux kernel module for Kernel Virtual Machine
virtualization environment.


%prep
%setup
%patch -p0
subst 's|^\(#include \)<\(linux/kvm.*\.h\)>|\1"include/\2"|' kernel/external-module-compat.h
echo "EXTRA_CFLAGS += -I\$(src)/include-compat" >> kernel/Kbuild


%build
export CFLAGS="%optflags"
./configure \
    --prefix=%_prefix \
    --qemu-cflags="%optflags" \
    %{subst_enable werror} \
    %{?_disable_sdl:--disable-sdl} \
    %{?_disable_curses:--disable-curses} \
    %{subst_enable alsa} \
    %{subst_enable esd} \
    %{subst_enable ac97} \
    %{subst_enable adlib} \
    %{subst_enable gus} \
    %{?_disable_vnc_tls:--disable-vnc-tls} \
    --disable-gcc-check \
    --disable-gfx-check

%make_build qemu


%install
%make_install DESTDIR=%buildroot initdir=%_initdir install-rpm

rm -f %buildroot%_sysconfdir/udev/rules.d/*
cat > %buildroot%_sysconfdir/udev/rules.d/%rulenum-%name.rules <<__RULE__
KERNEL=="%name", NAME="%%k", GROUP="%_group", MODE="0660"
__RULE__

rm -rf %buildroot{%_datadir,%_sysconfdir/%name,%_initdir}
mv -f %buildroot%_bindir/qemu-{system-x86_64,%name}
rm -f %buildroot%_bindir/{qemu-img,%name}
ln -sf {qemu-,%buildroot%_bindir/}%name
#install -m 0755 %name %buildroot%_bindir/

install -d -m 0755 kernel-source-%name-%version %buildroot%kernel_src
cp -r kernel/include* kernel-source-%name-%version/
install -m 0644 kernel/{Kbuild,*.{c,h}} kernel-source-%name-%version/
rm -f kernel-source-%name-%version/*.{spec,config}
tar -c kernel-source-%name-%version | bzip2 --best > %buildroot%kernel_src/kernel-source-%name-%version.tar.bz2
rm -rf kernel-source-%name-%version


%post
%_sbindir/groupadd -r -f %_group &> /dev/null ||:


%files
%_bindir/*
%_sysconfdir/udev/rules.d/*


%files -n kernel-source-%name
%kernel_src/*


%changelog
* Thu Apr 17 2008 Led <led@altlinux.ru> 66-alt1
- 66

* Tue Apr 08 2008 Led <led@altlinux.ru> 65-alt1
- 65

* Thu Mar 27 2008 Led <led@altlinux.ru> 64-alt1
- 64

* Mon Mar 17 2008 Led <led@altlinux.ru> 63-alt1
- 63

* Wed Feb 27 2008 Led <led@altlinux.ru> 62-alt1
- 62:
  + fixed vulnerability (SA29129)

* Sat Feb 23 2008 Led <led@altlinux.ru> 61-alt1
- 61:
  + AC97 emulation
  + Adlib emulation
  + Gravis Ultrasound emulation
  + EsounD audio driver
- fixed Kbuild
- added qemu-flags.patch
  
* Mon Feb 11 2008 Led <led@altlinux.ru> 60-alt0.2
- fixed spec

* Sun Feb 10 2008 Led <led@altlinux.ru> 60-alt0.1
- initial build
